use crate::cli::prelude::*;

#[derive(Subcommand)]
pub enum Command {
    Me(MeArgs),
}

impl Command {
    pub async fn exec(&self, tasks: SharedTasks) -> Result<()> {
        match self {
            Command::Me(args) => args.me(tasks).await,
        }
    }
}

#[derive(Parser)]
pub struct MeArgs {}

impl MeArgs {
    pub async fn me(&self, tasks: SharedTasks) -> Result<()> {
        println!("{:#?}", tasks.gitlab()?.me().await?);
        Ok(())
    }
}
