use crate::cli::prelude::*;

#[derive(Subcommand)]
pub enum Command {
    Issue(IssueArgs),
    Me(MeArgs),
}

impl Command {
    pub async fn exec(&self, tasks: SharedTasks) -> Result<()> {
        match self {
            Command::Issue(args) => args.issue(tasks).await,
            Command::Me(args) => args.me(tasks).await,
        }
    }
}

#[derive(Args)]
pub struct IssueArgs {
    #[arg(short, long)]
    pub key: String,
}
impl IssueArgs {
    pub async fn issue(&self, tasks: SharedTasks) -> Result<()> {
        println!("{:#?}", tasks.jira()?.issue(&self.key).await?);
        Ok(())
    }
}

#[derive(Args)]
pub struct MeArgs {}
impl MeArgs {
    pub async fn me(&self, tasks: SharedTasks) -> Result<()> {
        println!("{:#?}", tasks.jira()?.me().await?);
        Ok(())
    }
}
